# Customization Strategies

There is two main way to create your Keycloak theme.

## CSS Level Customization

This is the recomended approach as it is easy to implement and easy to maintain. Even non web developer should be able to pull it off.

In this approach you'll use your favorite styling solution it can be:

* Plain CSS
* [Tailwind](https://tailwindcss.com/docs/reusing-styles#extracting-classes-with-apply)
* A language superset of CSS lile [Sass](https://sass-lang.com/) or [Less](https://lesscss.org/)
* An utility class based CSS framework like [Bootstrap](https://getbootstrap.com/) or [Fundation](https://get.foundation/)

{% content-ref url="/pages/8QvCEcHqtalyqFo9zEKF" %}
[CSS Level Customization](/keycloakify/v10/customization-strategies/css-level-customization.md)
{% endcontent-ref %}

## React Component Level Customization

If you want to use your React component library like [Shadecn/UI](https://ui.shadcn.com/), [MUI](https://mui.com/) or [Ant](https://ant.design/) you have to go down at the component level.

{% content-ref url="/pages/DKyTa9bcRDgRhXFRYeqf" %}
[Component Level Customization](/keycloakify/v10/customization-strategies/component-level-customization.md)
{% endcontent-ref %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.keycloakify.dev/keycloakify/v10/customization-strategies.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
